Author Topic: Lisp to move attributes  (Read 21878 times)

0 Members and 1 Guest are viewing this topic.

Least

  • Guest
Re: Lisp to move attributes
« Reply #15 on: December 03, 2007, 11:59:51 AM »
Right clicking has the same effect.
thanks for looking into it.

T.Willey

  • Needs a day job
  • Posts: 5251
Re: Lisp to move attributes
« Reply #16 on: December 03, 2007, 12:05:34 PM »
Looks like the space bar will work also.  I don't think I gave the sub, sorry.
Code: [Select]
(defun GetBBPoints (VlaxObj / tmpLL tmpUR LowLeft LowRight UpRight LowRight)
; Get bounding box points for a valid vlax-object
; Returns a list of point lists.

(vla-GetBoundingBox VlaxObj 'tmpLL 'tmpUR)
(setq LowLeft (safearray-value tmpLL))
(setq UpRight (safearray-value tmpUR))
(setq LowRight (list (car UpRight) (cadr LowLeft) (caddr UpRight)))
(setq UpLeft (list (car LowLeft) (cadr UpRight) (caddr LowLeft)))
(list LowLeft LowRight UpRight UpLeft)
)
Tim

I don't want to ' end-up ', I want to ' become '. - Me

Please think about donating if this post helped you.

Least

  • Guest
Re: Lisp to move attributes
« Reply #17 on: December 03, 2007, 12:21:47 PM »
ah yes!
thats done it

thank you very much, its perfect!

Least

  • Guest
Re: Lisp to move attributes
« Reply #18 on: December 03, 2007, 12:27:21 PM »
T.Willey

I have a request please

with VovKa's single attribute routine the first picked point is used as the base point for the move
is it possible to modify this routine so that the last picked attribute is used as the base point for the move?

thanks

T.Willey

  • Needs a day job
  • Posts: 5251
Re: Lisp to move attributes
« Reply #19 on: December 03, 2007, 01:20:22 PM »
ah yes!
thats done it

thank you very much, its perfect!
You're welcome.

T.Willey

I have a request please

with VovKa's single attribute routine the first picked point is used as the base point for the move
is it possible to modify this routine so that the last picked attribute is used as the base point for the move?

thanks
Kind of, but not really.  Mine works with a routine to simulate 'ssget' with attributes, so it doesn't know which one is the last one picked, but it does return a list of all the objects selected, so you could use the last item in the list, and grab it's insertion point (or text alignment point if not left justified) and use that for the base point.
Tim

I don't want to ' end-up ', I want to ' become '. - Me

Please think about donating if this post helped you.

Least

  • Guest
Re: Lisp to move attributes
« Reply #20 on: December 03, 2007, 02:18:45 PM »
insertion point, anything will do really its just to save an extra mouse click

I guess that this area would need modifying:

      (progn
         (setvar 'cmdecho 1)
         (command "_.move"
            Plss
            ""
            (setq BasePt (getpoint))
            pause
         )

I think i need to edit its so that BasePt is set to the insertion point of the last attribute or any attribute.
How can I set BasePt the coord value of LowLeft (?)?

Cheers

T.Willey

  • Needs a day job
  • Posts: 5251
Re: Lisp to move attributes
« Reply #21 on: December 03, 2007, 02:24:23 PM »
insertion point, anything will do really its just to save an extra mouse click

I guess that this area would need modifying:

      (progn
         (setvar 'cmdecho 1)
         (command "_.move"
            Plss
            ""
            (setq BasePt (getpoint))
            pause
         )

I think i need to edit its so that BasePt is set to the insertion point of the last attribute or any attribute.
How can I set BasePt the coord value of LowLeft (?)?

Cheers
In this area
Code: [Select]
(foreach obj ObjList
(setq tempPtList (GetBBPoints obj))
(setq PtList nil)
(foreach pt tempPtList
(setq PtList (cons (car pt) PtList))
(setq PtList (cons (cadr pt) PtList))
)
(setq tempPline
(vlax-invoke
CurSpace
'AddLightWeightPolyline
(reverse PtList)
)
)
(vla-put-Closed tempPline :vlax-true)
(ssadd (vlax-vla-object->ename tempPline) Plss)
)
Add this line
Code: [Select]
(setq BasePt (car PtList))like
Code: [Select]
(foreach obj ObjList
(setq tempPtList (GetBBPoints obj))
                        [color=red](setq BasePt (car PtList))[/color]
(setq PtList nil)
(foreach pt tempPtList
(setq PtList (cons (car pt) PtList))
(setq PtList (cons (cadr pt) PtList))
)
(setq tempPline
(vlax-invoke
CurSpace
'AddLightWeightPolyline
(reverse PtList)
)
)
(vla-put-Closed tempPline :vlax-true)
(ssadd (vlax-vla-object->ename tempPline) Plss)
)
Then change this part
Code: [Select]
      (progn
         (setvar 'cmdecho 1)
         (command "_.move"
            Plss
            ""
            (setq BasePt (getpoint))
            pause
         )
to
Code: [Select]
      (progn
         (setvar 'cmdecho 1)
         (command "_.move"
            Plss
            ""
            [color=red]BasePt[/color]
            pause
         )
Tim

I don't want to ' end-up ', I want to ' become '. - Me

Please think about donating if this post helped you.

VovKa

  • Water Moccasin
  • Posts: 1631
  • Ukraine
Re: Lisp to move attributes
« Reply #22 on: December 03, 2007, 02:38:30 PM »
first of all, thank you T.Willey, you have rescued me trouble :)
Least, you can use this expression to set center point of a selection as a base point
Code: [Select]
(setq
  BasePt (apply
   (function
     (lambda (p1 p2)
       (mapcar (function (lambda (e1 e2) (/ (+ e1 e2) 2.))) p1 p2)
     )
   )
   ((lambda (Coords)
      (apply
(function
  (lambda (mn mx) (mapcar (function (lambda (n x) (list n x))) mn mx))
)
(mapcar (function (lambda (c) (list (apply 'min c) (apply 'max c))))
(list (mapcar 'car Coords) (mapcar 'cadr Coords))
)
      )
    )
     (apply
       'append
       (mapcar
(function (lambda (Obj)
     (vla-GetBoundingBox Obj 'LL 'UR)
     (list (vlax-safearray->list LL) (vlax-safearray->list UR))
   )
)
ObjList
       )
     )
   )
)
)
don't forget to add LL and UR to locals

T.Willey

  • Needs a day job
  • Posts: 5251
Re: Lisp to move attributes
« Reply #23 on: December 03, 2007, 02:40:34 PM »
first of all, thank you T.Willey, you have rescued me trouble :)
You're welcome.  It's nice when you can help others that help so much.
Tim

I don't want to ' end-up ', I want to ' become '. - Me

Please think about donating if this post helped you.

Least

  • Guest
Re: Lisp to move attributes
« Reply #24 on: December 03, 2007, 03:32:27 PM »
Ok

i've added the two lines as instructed and run the command:

Command:  MOVEATTTEXT
Select attributes and/or text to move:
Select attributes and/or text to move:
Select attributes and/or text to move:
Select attributes and/or text to move: _.move
Select objects:   3 found

Select objects: Specify base point or displacement: 490.2615999989041 Specify
second point of displacement or <use first point as displacement>:
Command:

not quite workng as yet, the base point comes from somewhere way of screen.

so then i commented out this line
;         (setq BasePt (car PtList))

and inserted the extra code from Vovka (thank you Vovka)
inserted just before this bit:

   (if (> (sslength Plss) 0)
      (progn
         (setvar 'cmdecho 1)
         (command "_.move"

now it will find the centre point perfetly but i cannot move the attributes.

Command:  MOVEATTTEXT
Select attributes and/or text to move:
Specify the opposite corner:
Select attributes and/or text to move: _.move
Select objects:   2 found

Select objects: Specify base point or displacement: Specify second point of
displacement or <use first point as displacement>:
Command:

cheers.

T.Willey

  • Needs a day job
  • Posts: 5251
Re: Lisp to move attributes
« Reply #25 on: December 03, 2007, 03:38:34 PM »
Sorry.  I mis-typed what you wanted to set 'BasePt' to.  It should have been
Code: [Select]
(setq BasePt (car tempPtList))
I just tried it in my routine, and it worked.
Tim

I don't want to ' end-up ', I want to ' become '. - Me

Please think about donating if this post helped you.

Least

  • Guest
Re: Lisp to move attributes
« Reply #26 on: December 03, 2007, 03:49:22 PM »
Yes! Fantastic, it works like a dream.  Thank you for your time and expertise.

It would be nice to fix Vovka's centre point function.
I have no idea how to find the error.

Thanks to both you with this.

Least

VovKa

  • Water Moccasin
  • Posts: 1631
  • Ukraine
Re: Lisp to move attributes
« Reply #27 on: December 03, 2007, 04:52:49 PM »
of course 'Move expects a 3d point, sorry
when using my center point change the following
Code: [Select]
(foreach obj ObjList
  (vlax-invoke obj 'Move (append BasePt (cddr NewPt)) NewPt)
)

Least

  • Guest
Re: Lisp to move attributes
« Reply #28 on: December 03, 2007, 05:18:30 PM »
Brilliant, its just the job
thanks for all your help

here it is in full:

Quote
;   Lisp to move attributes
;   
;   Thanks to T.Willey & VovKa - Dec 2007
;   http://www.theswamp.org/index.php?topic=19881.15


(defun SelAtts (Message bAllowText / Sel EntData Pt1 Pt3 gr p1 p2 p3 p4 po   ss SelMode SelObjList flag)
; updated by gile @theSwamp.org to show the selection correctly.
; updated by T.Willey to allow the option to select text objects, not mtext
; updated by T.Willey, added new sub to see if the selection box and the bounding box of the objects
;    selected cross, so that a true crossing is simulated

   (defun DoBoxesCross (PtList1 PtList2 / Intersect cnt cnt2)
   
      (setq cnt 0)
      (while
         (and
            (not Intersect)
            (< cnt 4)
         )
         (setq cnt2 0)
         (repeat 4
            (if
               (inters
                  (nth cnt PtList1)
                  (nth
                     (if (equal cnt 3)
                        0
                        (1+ cnt)
                     )
                     PtList1
                  )
                  (nth cnt2 PtList2)
                  (nth
                     (if (equal cnt2 3)
                        0
                        (1+ cnt2)
                     )
                     PtList2
                  )
                  T
               )
               (setq Intersect T)
            )
            (setq cnt2 (1+ cnt2))
         )
         (setq cnt (1+ cnt))
      )
      Intersect
   )
;----------------------------------------------------------------------------------------------------
   (defun GetAttSelection (ss SelMode / ObjList PtList TestList ll ur tempPtList SelObjList)
   
      (foreach lst (ssnamex ss)
         (cond
            ((equal (car lst) 3)
               (setq ObjList (cons (vlax-ename->vla-object (cadr lst)) ObjList))
            )
            ((equal (car lst) -1)
               (foreach sub-lst (cdr lst)
                  (setq PtList (cons (cadr sub-lst) PtList))
               )
            )
         )
      )
      (foreach obj ObjList
         (cond
            ((= (vla-get-ObjectName obj) "AcDbBlockReference")
               (foreach att (vlax-invoke obj 'GetAttributes)
                  (if
                     (and
                        (/= (vla-get-TextString att) "")
                        (= (vla-get-Invisible att) :vlax-false)
                     )
                     (progn
                        (setq TestList nil)
                        (vla-GetBoundingBox att 'll 'ur)
                        (setq tempPtList
                           (list
                              (setq ll (safearray-value ll))
                              (setq ur (safearray-value ur))
                              (list (car ur) (cadr ll) (caddr ll))
                              (list (car ll) (cadr ur) (caddr ll))
                           )
                        )
                        (foreach pt tempPtList
                           (if
                              (and
                                 (< (caar PtList) (car pt) (caadr PtList))
                                 (< (cadar PtList) (cadr pt) (cadr (caddr PtList)))
                              )
                              (setq TestList (cons T TestList))
                           )
                        )
                        (if (= SelMode "Windowing")
                           (if (equal (length TestList) 4)
                              (setq SelObjList (cons att SelObjList))
                           )
                           (if
                              (or
                                 TestList
                                 (DoBoxesCross PtList tempPtList)
                              )
                              (setq SelObjList (cons att SelObjList))
                           )
                        )
                     )
                  )
               )
            )
            (
               (or
                  (= (vla-get-ObjectName obj) "AcDbText")
                  (= (vla-get-ObjectName obj) "AcDbAttributeDefinition")
               )
               (if
                  (or
                     (/= (vla-get-TextString obj) "")
                     (and
                        (vlax-property-available-p obj 'TagString)
                        (/= (vla-get-TagString obj) "")
                     )
                  )
                  (progn
                     (setq TestList nil)
                     (vla-GetBoundingBox obj 'll 'ur)
                     (setq tempPtList
                        (list
                           (setq ll (safearray-value ll))
                           (setq ur (safearray-value ur))
                           (list (car ur) (cadr ll) (caddr ll))
                           (list (car ll) (cadr ur) (caddr ll))
                        )
                     )
                     (foreach pt tempPtList
                        (if
                           (and
                              (< (caar PtList) (car pt) (caadr PtList))
                              (< (cadar PtList) (cadr pt) (cadr (caddr PtList)))
                           )
                           (setq TestList (cons T TestList))
                        )
                     )
                     (if (= SelMode "Windowing")
                        (if (equal (length TestList) 4)
                           (setq SelObjList (cons obj SelObjList))
                        )
                        (if
                           (or
                              TestList
                              (DoBoxesCross PtList tempPtList)
                           )
                           (setq SelObjList (cons obj SelObjList))
                        )
                     )
                  )
               )
            )
         )
      )
      SelObjList
   )
;----------------------------------------------------------------------------------------------------
    (defun gr-sel   (/ loop gr pt)
   
      (setq loop T)
      (while (and (setq gr (grread T 12 2)) (/= (car gr) 3) loop)
         (cond
            ((= (car gr) 5)
               (setq pt (cadr gr))
            )
            (
               (or
                  (member gr '((2 13) (2 32)))
                  (or (= (car gr) 11) (= (car gr) 25))
               )
               (setq loop nil
                  pt   nil
               )
            )
         )
      )
      (if   pt
         (cond
            ((car (nentselp pt)))
            (pt)
         )
      )
   )
;---------------------------------------------------------------------------------------------------------
   (setvar "ErrNo" 0)
   (while
      (and
         (princ (strcat "\n" Message))
         (setq sel (gr-sel))
      )
      (if   (listp sel)
         (progn
            (setq p1  (list (car sel) (cadr sel))
               pt1 (trans p1 1 2)
            )
            (princ "\nSpecify the opposite corner: ")
            (while (and (setq gr (grread T 12 1)) (/= (car gr) 3))
               (if (= 5 (car gr))
                  (progn
                     (redraw)
                     (setq pt3   (trans (cadr gr) 1 2)
                        p2   (trans (list (car pt3) (cadr pt1)) 2 1)
                        p3   (list (caadr gr) (cadadr gr))
                        p4   (trans (list (car pt1) (cadr pt3)) 2 1)
                     )
                     (if (< (car pt1) (car (trans p2 1 2)))
                        (progn
                           (setq SelMode "Windowing")
                           (grvecs (list 255 p1 p2 255 p2 p3 255 p3 p4 255 p4 p1))
                        )
                        (progn
                           (setq SelMode "Crossing")
                           (grvecs
                              (list -255 p1 p2 -255 p2 p3 -255 p3 p4 -255 p4 p1)
                           )
                        )
                     )
                  )
               )
            )
            (redraw)
            (if
               (if bAllowText
                  (setq ss (ssget "_C" p1 p3 '((0 . "INSERT,TEXT,ATTDEF"))))
                  (setq ss (ssget "_C" p1 p3 '((0 . "INSERT"))))
               )
               (setq SelObjList (append SelObjList (GetAttSelection ss SelMode)))
            )
         )
         (progn
            (setq EntData (entget Sel))
            (if
               (or
                  (= (cdr (assoc 0 EntData)) "ATTRIB")
                  (and
                     bAllowText
                     (vl-position (cdr (assoc 0 EntData)) '("TEXT" "ATTDEF"))
                  )
               )
               (progn
                  (setq SelObjList
                     (cons (vlax-ename->vla-object Sel) SelObjList)
                  )
                  (redraw Sel 3)
               )
            )
         )
      )
      (foreach att SelObjList
         (redraw (vlax-vla-object->ename att) 3)
      )
   )
   (foreach att SelObjList
      (redraw (vlax-vla-object->ename att) 4)
   )
   SelObjList
)


;----------------------------------------------------------------------------------------------------
(defun GetBBPoints (VlaxObj / tmpLL tmpUR LowLeft LowRight UpRight LowRight)
; Get bounding box points for a valid vlax-object
; Returns a list of point lists.

   (vla-GetBoundingBox VlaxObj 'tmpLL 'tmpUR)
   (setq LowLeft (safearray-value tmpLL))
   (setq UpRight (safearray-value tmpUR))
   (setq LowRight (list (car UpRight) (cadr LowLeft) (caddr UpRight)))
   (setq UpLeft (list (car LowLeft) (cadr UpRight) (caddr LowLeft)))
   (list LowLeft LowRight UpRight UpLeft)
)


;---------------------------------------------------------------------------------------------------------


(defun c:MoveAttText (/ ActDoc Plss CurSpace ObjList tempPtList PtList tempPline BasePt NewPt *error* LL UR)

   (defun *error* (msg)
   
      (command)
      (if (> (sslength Plss) 0)
         (command "_.erase" Plss "")
      )
      (vla-EndUndoMark ActDoc)
   )

   (defun GetCurrentSpace (Doc / BlkCol SpaceList CurSpace ActSpace temp1)
   ; Returns the "block object" for the active space
   ; Thanks to Jeff Mishler

      (if (= (getvar "cvport") 1)
         (vla-get-PaperSpace Doc)
         (vla-get-ModelSpace Doc)
      )
   )

   
   (setq ActDoc (vla-get-ActiveDocument (vlax-get-Acad-Object)))
   (vla-EndUndoMark ActDoc)
   (vla-StartUndoMark ActDoc)
   (setq Plss (ssadd))
   (setq CurSpace (GetCurrentSpace ActDoc))
   (if (setq ObjList (SelAtts "Select attributes and/or text to move: " T))
      (foreach obj ObjList
         (setq tempPtList (GetBBPoints obj))
         (setq BasePt (car tempPtList))
         (setq PtList nil)
         (foreach pt tempPtList
            (setq PtList (cons (car pt) PtList))
            (setq PtList (cons (cadr pt) PtList))
         )
         (setq tempPline
            (vlax-invoke
               CurSpace
               'AddLightWeightPolyline
               (reverse PtList)
            )
         )
         (vla-put-Closed tempPline :vlax-true)
         (ssadd (vlax-vla-object->ename tempPline) Plss)
      )
   )

(setq
  BasePt (apply
      (function
        (lambda (p1 p2)
          (mapcar (function (lambda (e1 e2) (/ (+ e1 e2) 2.))) p1 p2)
        )
      )
      ((lambda (Coords)
         (apply
      (function
        (lambda (mn mx) (mapcar (function (lambda (n x) (list n x))) mn mx))
      )
      (mapcar   (function (lambda (c) (list (apply 'min c) (apply 'max c))))
         (list (mapcar 'car Coords) (mapcar 'cadr Coords))
      )
         )
       )
        (apply
          'append
          (mapcar
       (function (lambda (Obj)
              (vla-GetBoundingBox Obj 'LL 'UR)
              (list (vlax-safearray->list LL) (vlax-safearray->list UR))
            )
       )
       ObjList
          )
        )
      )
    )
)

   (if (> (sslength Plss) 0)
      (progn
         (setvar 'cmdecho 1)
         (command "_.move"
            Plss
            ""
            BasePt
            pause
         )
         (setq NewPt (getvar 'lastpoint))
         (setvar 'cmdecho 0)
         (command "_.erase" Plss "")
         (foreach obj ObjList
           (vlax-invoke obj 'Move (append BasePt (cddr NewPt)) NewPt)
         )
      )
   )
   (vla-EndUndoMark ActDoc)
   (princ)
)



Pad

  • Bull Frog
  • Posts: 342
Re: Lisp to move attributes
« Reply #29 on: November 03, 2009, 09:25:28 AM »
Resurrecting this old post

Vovka's original lisp is great for quickly moving one attribute with the minimum of clicks.
The lisp with the addition of T.Willey's code (in the post above) is great for moving multiple attributes, where you select which ones you want to move.
I would also like a lisp which would automatically select all the blocks attributes for moving after clicking on just one of the attributes, is this possible?
Fingers crossed that its just a simple modification.
Any help would be appreciated.

Thanks


« Last Edit: November 03, 2009, 09:31:03 AM by Pad »